diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
new file mode 100644
index 97ef618..48f208a
*** a/doc/src/sgml/catalogs.sgml
--- b/doc/src/sgml/catalogs.sgml
***************
*** 549,762 ****
       </row>
  
       <row>
!       <entry><structfield>amstrategies</structfield></entry>
!       <entry><type>int2</type></entry>
!       <entry></entry>
!       <entry>Number of operator strategies for this access method,
!        or zero if access method does not have a fixed set of operator
!        strategies</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amsupport</structfield></entry>
!       <entry><type>int2</type></entry>
!       <entry></entry>
!       <entry>Number of support routines for this access method</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcanorder</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support ordered scans sorted by the
!        indexed column's value?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcanorderbyop</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support ordered scans sorted by the result
!        of an operator on the indexed column?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcanbackward</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support backward scanning?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcanunique</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support unique indexes?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcanmulticol</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support multicolumn indexes?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amoptionalkey</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support a scan without any constraint
!        for the first index column?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amsearcharray</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support <literal>ScalarArrayOpExpr</> searches?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amsearchnulls</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does the access method support <literal>IS NULL</>/<literal>NOT NULL</> searches?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amstorage</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Can index storage data type differ from column data type?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amclusterable</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Can an index of this type be clustered on?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>ampredlocks</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>Does an index of this type manage fine-grained predicate locks?</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amkeytype</structfield></entry>
        <entry><type>oid</type></entry>
-       <entry><literal><link linkend="catalog-pg-type"><structname>pg_type</structname></link>.oid</literal></entry>
-       <entry>Type of data stored in index, or zero if not a fixed type</entry>
-      </row>
- 
-      <row>
-       <entry><structfield>aminsert</structfield></entry>
-       <entry><type>regproc</type></entry>
        <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Insert this tuple</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>ambeginscan</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Prepare for index scan</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amgettuple</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Next valid tuple</quote> function, or zero if none</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amgetbitmap</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Fetch all valid tuples</quote> function, or zero if none</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amrescan</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>(Re)start index scan</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amendscan</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Clean up after index scan</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>ammarkpos</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Mark current scan position</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amrestrpos</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Restore marked scan position</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>ambuild</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Build new index</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>ambuildempty</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry><quote>Build empty index</quote> function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>ambulkdelete</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Bulk-delete function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amvacuumcleanup</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Post-<command>VACUUM</command> cleanup function</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcanreturn</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Function to check whether an index column supports index-only
!        scans. Can be zero if index-only scans are never supported.</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amcostestimate</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Function to estimate cost of an index scan</entry>
!      </row>
! 
!      <row>
!       <entry><structfield>amoptions</structfield></entry>
!       <entry><type>regproc</type></entry>
!       <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Function to parse and validate <structfield>reloptions</> for an index</entry>
       </row>
- 
      </tbody>
     </tgroup>
    </table>
--- 549,562 ----
       </row>
  
       <row>
!       <entry><structfield>amhandler</structfield></entry>
        <entry><type>oid</type></entry>
        <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>
!        References a handler function that is responsible for
!        supplying execution routines for the access method.
!       </entry>
       </row>
      </tbody>
     </tgroup>
    </table>
diff --git a/doc/src/sgml/indexam.sgml b/doc/src/sgml/indexam.sgml
new file mode 100644
index 1c09bae..3ff3651
*** a/doc/src/sgml/indexam.sgml
--- b/doc/src/sgml/indexam.sgml
***************
*** 49,61 ****
    <para>
     Each index access method is described by a row in the
     <structname>pg_am</structname> system catalog (see
!    <xref linkend="catalog-pg-am">).  The principal contents of a
!    <structname>pg_am</structname> row are references to
!    <link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>
!    entries that identify the index access
!    functions supplied by the access method.  The APIs for these functions
!    are defined later in this chapter.  In addition, the
!    <structname>pg_am</structname> row specifies a few fixed properties of
     the access method, such as whether it can support multicolumn indexes.
     There is not currently any special support
     for creating or deleting <structname>pg_am</structname> entries;
--- 49,63 ----
    <para>
     Each index access method is described by a row in the
     <structname>pg_am</structname> system catalog (see
!    <xref linkend="catalog-pg-am">).  In the <structname>pg_am</structname> row
!    the handler function is specified by the reference to
!    <link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.
!    Handler function must be written in a compiled language such as C, using
!    the version-1 interface.  The handler function simply returns a
!    <structname>IndexAmRoutine</structname> struct which contains function
!    pointers to callback functions that will be called by the planner, executor,
!    and various maintenance commands.  In addition, the
!    <structname>IndexAmRoutine</structname> contains a few fixed properties of
     the access method, such as whether it can support multicolumn indexes.
     There is not currently any special support
     for creating or deleting <structname>pg_am</structname> entries;
***************
*** 96,126 ****
    </para>
  
    <para>
!    Some of the flag columns of <structname>pg_am</structname> have nonobvious
!    implications.  The requirements of <structfield>amcanunique</structfield>
!    are discussed in <xref linkend="index-unique-checks">.
!    The <structfield>amcanmulticol</structfield> flag asserts that the
!    access method supports multicolumn indexes, while
!    <structfield>amoptionalkey</structfield> asserts that it allows scans
     where no indexable restriction clause is given for the first index column.
!    When <structfield>amcanmulticol</structfield> is false,
!    <structfield>amoptionalkey</structfield> essentially says whether the
     access method supports full-index scans without any restriction clause.
     Access methods that support multiple index columns <emphasis>must</>
     support scans that omit restrictions on any or all of the columns after
     the first; however they are permitted to require some restriction to
     appear for the first index column, and this is signaled by setting
!    <structfield>amoptionalkey</structfield> false.
!    One reason that an index AM might set
!    <structfield>amoptionalkey</structfield> false is if it doesn't index
!    null values.  Since most indexable operators are
     strict and hence cannot return true for null inputs,
     it is at first sight attractive to not store index entries for null values:
     they could never be returned by an index scan anyway.  However, this
     argument fails when an index scan has no restriction clause for a given
     index column.  In practice this means that
!    indexes that have <structfield>amoptionalkey</structfield> true must
!    index nulls, since the planner might decide to use such an index
     with no scan keys at all.  A related restriction is that an index
     access method that supports multiple index columns <emphasis>must</>
     support indexing null values in columns after the first, because the planner
--- 98,133 ----
    </para>
  
    <para>
!    Some of the flag fields of <structname>IndexAmRoutine</structname> have nonobvious
!    implications.  The requirements of
!    <structname>IndexAmRoutine</structname>.<structfield>amcanunique</structfield>
!    are discussed in <xref linkend="index-unique-checks">. The
!    <structname>IndexAmRoutine</structname>.<structfield>amcanmulticol</structfield>
!    flag asserts that the access method supports multicolumn indexes, while
!    <structname>IndexAmRoutine</structname>.<structfield>amoptionalkey</structfield>
!    asserts that it allows scans
     where no indexable restriction clause is given for the first index column.
!    When <structname>IndexAmRoutine</structname>.<structfield>amcanmulticol</structfield>
!    is false,
!    <structname>IndexAmRoutine</structname>.<structfield>amoptionalkey</structfield>
!    essentially says whether the
     access method supports full-index scans without any restriction clause.
     Access methods that support multiple index columns <emphasis>must</>
     support scans that omit restrictions on any or all of the columns after
     the first; however they are permitted to require some restriction to
     appear for the first index column, and this is signaled by setting
!    <structname>IndexAmRoutine</structname>.<structfield>amoptionalkey</structfield>
!    false.  One reason that an index AM might set
!    <structname>IndexAmRoutine</structname>.<structfield>amoptionalkey</structfield>
!    false is if it doesn't index null values.  Since most indexable operators are
     strict and hence cannot return true for null inputs,
     it is at first sight attractive to not store index entries for null values:
     they could never be returned by an index scan anyway.  However, this
     argument fails when an index scan has no restriction clause for a given
     index column.  In practice this means that
!    indexes that have
!    <structname>IndexAmRoutine</structname>.<structfield>amoptionalkey</structfield>
!    true must index nulls, since the planner might decide to use such an index
     with no scan keys at all.  A related restriction is that an index
     access method that supports multiple index columns <emphasis>must</>
     support indexing null values in columns after the first, because the planner
***************
*** 131,139 ****
     index omits rows where <literal>b</> is null.
     It is, however, OK to omit rows where the first indexed column is null.
     An index access method that does index nulls may also set
!    <structfield>amsearchnulls</structfield>, indicating that it supports
!    <literal>IS NULL</> and <literal>IS NOT NULL</> clauses as search
!    conditions.
    </para>
  
   </sect1>
--- 138,146 ----
     index omits rows where <literal>b</> is null.
     It is, however, OK to omit rows where the first indexed column is null.
     An index access method that does index nulls may also set
!    <structname>IndexAmRoutine</structname>.<structfield>amsearchnulls</structfield>,
!    indicating that it supports <literal>IS NULL</> and <literal>IS NOT NULL</>
!    clauses as search conditions.
    </para>
  
   </sect1>
***************
*** 143,149 ****
  
    <para>
     The index construction and maintenance functions that an index access
!    method must provide are:
    </para>
  
    <para>
--- 150,156 ----
  
    <para>
     The index construction and maintenance functions that an index access
!    method must provide in <structname>IndexAmRoutine</structname> are:
    </para>
  
    <para>
*************** aminsert (Relation indexRelation,
*** 188,194 ****
     <literal>isnull</> arrays give the key values to be indexed, and
     <literal>heap_tid</> is the TID to be indexed.
     If the access method supports unique indexes (its
!    <structname>pg_am</>.<structfield>amcanunique</> flag is true) then
     <literal>checkUnique</> indicates the type of uniqueness check to
     perform.  This varies depending on whether the unique constraint is
     deferrable; see <xref linkend="index-unique-checks"> for details.
--- 195,201 ----
     <literal>isnull</> arrays give the key values to be indexed, and
     <literal>heap_tid</> is the TID to be indexed.
     If the access method supports unique indexes (its
!    <structfield>amcanunique</> flag is true) then
     <literal>checkUnique</> indicates the type of uniqueness check to
     perform.  This varies depending on whether the unique constraint is
     deferrable; see <xref linkend="index-unique-checks"> for details.
*************** amcanreturn (Relation indexRelation, int
*** 281,288 ****
     the form of an <structname>IndexTuple</structname>.  The attribute number
     is 1-based, i.e. the first columns attno is 1. Returns TRUE if supported,
     else FALSE.  If the access method does not support index-only scans at all,
!    the <structfield>amcanreturn</> field in its <structname>pg_am</> row can
!    be set to zero.
    </para>
  
    <para>
--- 288,295 ----
     the form of an <structname>IndexTuple</structname>.  The attribute number
     is 1-based, i.e. the first columns attno is 1. Returns TRUE if supported,
     else FALSE.  If the access method does not support index-only scans at all,
!    the <structfield>amcanreturn</> field in its <structname>IndexAmRoutine</>
!    struct can be set to NULL.
    </para>
  
    <para>
*************** amgettuple (IndexScanDesc scan,
*** 414,421 ****
    <para>
     The <function>amgettuple</> function need only be provided if the access
     method supports <quote>plain</> index scans.  If it doesn't, the
!    <structfield>amgettuple</> field in its <structname>pg_am</> row must
!    be set to zero.
    </para>
  
    <para>
--- 421,428 ----
    <para>
     The <function>amgettuple</> function need only be provided if the access
     method supports <quote>plain</> index scans.  If it doesn't, the
!    <structfield>amgettuple</> field in its <structname>IndexAmRoutine</>
!    struct must be set to NULL.
    </para>
  
    <para>
*************** amgetbitmap (IndexScanDesc scan,
*** 445,452 ****
    <para>
     The <function>amgetbitmap</> function need only be provided if the access
     method supports <quote>bitmap</> index scans.  If it doesn't, the
!    <structfield>amgetbitmap</> field in its <structname>pg_am</> row must
!    be set to zero.
    </para>
  
    <para>
--- 452,459 ----
    <para>
     The <function>amgetbitmap</> function need only be provided if the access
     method supports <quote>bitmap</> index scans.  If it doesn't, the
!    <structfield>amgetbitmap</> field in its <structname>IndexAmRoutine</>
!    struct must be set to NULL.
    </para>
  
    <para>
*************** amrestrpos (IndexScanDesc scan);
*** 477,494 ****
    </para>
  
    <para>
!    By convention, the <literal>pg_proc</literal> entry for an index
!    access method function should show the correct number of arguments,
!    but declare them all as type <type>internal</> (since most of the arguments
!    have types that are not known to SQL, and we don't want users calling
!    the functions directly anyway).  The return type is declared as
!    <type>void</>, <type>internal</>, or <type>boolean</> as appropriate.
!    The only exception is <function>amoptions</>, which should be correctly
!    declared as taking <type>text[]</> and <type>bool</> and returning
!    <type>bytea</>.  This provision allows client code to execute
!    <function>amoptions</> to test validity of options settings.
    </para>
- 
   </sect1>
  
   <sect1 id="index-scanning">
--- 484,496 ----
    </para>
  
    <para>
! <programlisting>
! void
! amvalidate (OpClassInfo *opclass);
! </programlisting>
!    Validates given operator class by access method. The <function>amvalidate</>
!    must throw an error if opclass is invalid.
    </para>
   </sect1>
  
   <sect1 id="index-scanning">
*************** amrestrpos (IndexScanDesc scan);
*** 548,554 ****
        <para>
         Access methods that always return entries in the natural ordering
         of their data (such as btree) should set
!        <structname>pg_am</>.<structfield>amcanorder</> to true.
         Currently, such access methods must use btree-compatible strategy
         numbers for their equality and ordering operators.
        </para>
--- 550,556 ----
        <para>
         Access methods that always return entries in the natural ordering
         of their data (such as btree) should set
!        <structfield>amcanorder</> to true.
         Currently, such access methods must use btree-compatible strategy
         numbers for their equality and ordering operators.
        </para>
*************** amrestrpos (IndexScanDesc scan);
*** 556,562 ****
       <listitem>
        <para>
         Access methods that support ordering operators should set
!        <structname>pg_am</>.<structfield>amcanorderbyop</> to true.
         This indicates that the index is capable of returning entries in
         an order satisfying <literal>ORDER BY</> <replaceable>index_key</>
         <replaceable>operator</> <replaceable>constant</>.  Scan modifiers
--- 558,564 ----
       <listitem>
        <para>
         Access methods that support ordering operators should set
!        <structfield>amcanorderbyop</> to true.
         This indicates that the index is capable of returning entries in
         an order satisfying <literal>ORDER BY</> <replaceable>index_key</>
         <replaceable>operator</> <replaceable>constant</>.  Scan modifiers
*************** amrestrpos (IndexScanDesc scan);
*** 579,585 ****
     methods that set <structfield>amcanorder</> to true.)  After the
     first call, <function>amgettuple</> must be prepared to advance the scan in
     either direction from the most recently returned entry.  (But if
!    <structname>pg_am</>.<structfield>amcanbackward</> is false, all subsequent
     calls will have the same direction as the first one.)
    </para>
  
--- 581,587 ----
     methods that set <structfield>amcanorder</> to true.)  After the
     first call, <function>amgettuple</> must be prepared to advance the scan in
     either direction from the most recently returned entry.  (But if
!    <structfield>amcanbackward</> is false, all subsequent
     calls will have the same direction as the first one.)
    </para>
  
*************** amrestrpos (IndexScanDesc scan);
*** 590,597 ****
     be remembered per scan; a new <function>ammarkpos</> call overrides the
     previously marked position.  An access method that does not support
     ordered scans should still provide mark and restore functions in
!    <structname>pg_am</>, but it is sufficient to have them throw errors if
!    called.
    </para>
  
    <para>
--- 592,599 ----
     be remembered per scan; a new <function>ammarkpos</> call overrides the
     previously marked position.  An access method that does not support
     ordered scans should still provide mark and restore functions in
!    <structname>IndexAmRoutine</>, but it is sufficient to have them throw
!    errors if called.
    </para>
  
    <para>
*************** amrestrpos (IndexScanDesc scan);
*** 766,772 ****
     <productname>PostgreSQL</productname> enforces SQL uniqueness constraints
     using <firstterm>unique indexes</>, which are indexes that disallow
     multiple entries with identical keys.  An access method that supports this
!    feature sets <structname>pg_am</>.<structfield>amcanunique</> true.
     (At present, only b-tree supports it.)
    </para>
  
--- 768,774 ----
     <productname>PostgreSQL</productname> enforces SQL uniqueness constraints
     using <firstterm>unique indexes</>, which are indexes that disallow
     multiple entries with identical keys.  An access method that supports this
!    feature sets <structfield>amcanunique</> true.
     (At present, only b-tree supports it.)
    </para>
  
diff --git a/doc/src/sgml/xindex.sgml b/doc/src/sgml/xindex.sgml
new file mode 100644
index 4fac018..a2d3fd8
*** a/doc/src/sgml/xindex.sgml
--- b/doc/src/sgml/xindex.sgml
***************
*** 34,40 ****
     regular access to tables is built into
     <productname>PostgreSQL</productname>, but all index methods are
     described in <classname>pg_am</classname>.  It is possible to add a
!    new index method by defining the required interface routines and
     then creating a row in <classname>pg_am</classname> &mdash; but that is
     beyond the scope of this chapter (see <xref linkend="indexam">).
    </para>
--- 34,41 ----
     regular access to tables is built into
     <productname>PostgreSQL</productname>, but all index methods are
     described in <classname>pg_am</classname>.  It is possible to add a
!    new index access method by defining the handler function, which returns
!    C-struct with required interface routines and parameters, and
     then creating a row in <classname>pg_am</classname> &mdash; but that is
     beyond the scope of this chapter (see <xref linkend="indexam">).
    </para>
